// Type definitions for @dyna-grid/core v1.0.5
// Project: 
// Definitions by: zhangkun <>
export declare type ResolveAndRejectCallback<T> = (resolve: (value: T | null) => void, reject: (params: any) => void) => void;
export declare enum DyPromiseStatus {
    IN_PROGRESS = 0,
    RESOLVED = 1
}
export declare class DyPromise<T> {
    private status;
    private resolution;
    private waiters;
    static all<T>(promises: DyPromise<T | null>[]): DyPromise<(T | null)[]>;
    static resolve<T>(value?: T | null): DyPromise<T>;
    constructor(callback: ResolveAndRejectCallback<T>);
    then<V>(func: (result: T | null) => V): DyPromise<V>;
    resolveNow<Z>(ifNotResolvedValue: Z, ifResolved: (current: T | null) => Z): Z;
    private onDone;
    private onReject;
}
